#ifdef TARGET_GLULX;
[ DumpHeap; "[Heap cannot be dumped in Glulx.]^"; ];
#endif;

#ifdef TARGET_ZCODE;
[ DumpHeap p len r t;
  print "=== Heap dump ===^";
  for (p = #heap_start: p < #heap_start + #heap_size: p = p+len+3) {
    len = (p+1)-->0;
    print p, ": ";
    switch (p->0) {
      0: print "Ready";
      1: print "Freed";
      2: print "Buffer";
      3: print "Struct";
      default: print p->0, "?";
    }
    if (p->0 == 3) {
      r = (p+3)-->0;
      t = (p+5)-->0;
      print " ";
      if (metaclass(t)==Routine)
        print (string) t(1);
      else
        print "(", t, ")";
      print ", ", r, " ref";
      if (r~=1) print "s";
    }
    print " - ", len, " bytes^";
  }
  print "=================^";
];
#endif;
